#pragma once

#include <Either.h>
#include <Vec3.h>
#include "WorldUpdate.h"

class Block;

class PlaceBlockUpdate : public WorldUpdate
{
private:
    Framework::Either<Block*, int> block;

protected:
    void write( Framework::StreamWriter* zWriter ) override;

public:
    PlaceBlockUpdate( Framework::Either<Block*, int> block, Framework::Vec3<int> location, int dimensionId );
    ~PlaceBlockUpdate();

    void onUpdate( Dimension* zDimension ) override;
    Block* zBlock() const;
};

class PlaceBlockUpdateType : WorldUpdateType
{
    REGISTRABLE( PlaceBlockUpdateType )

protected:
    PlaceBlockUpdateType();
};
REGISTER( PlaceBlockUpdateType, WorldUpdateType )